# generate impact score
def generate_impact_score(recommendation_df):
    # find the max/min/diff for org cnt
    max_org_cnt = recommendation_df["org_cnt"].max()
    min_org_cnt = recommendation_df["org_cnt"].min()
    org_cnt_diff = max_org_cnt - min_org_cnt
    if max_org_cnt > 0 and org_cnt_diff == 0:
        org_cnt_diff = 0.1
        min_org_cnt = min_org_cnt - 1
    # find the max/min/diff for dev cnt
    max_dev_cnt = recommendation_df["dev_cnt"].max()
    min_dev_cnt = recommendation_df["dev_cnt"].min()
    dev_cnt_diff = max_dev_cnt - min_dev_cnt
    if max_dev_cnt > 0 and dev_cnt_diff == 0:
        dev_cnt_diff = 0.1
        min_dev_cnt = min_dev_cnt - 1
    # find the max/min/diff for alert cnt
    max_alert_cnt = recommendation_df["alert_cnt"].max()
    min_alert_cnt = recommendation_df["alert_cnt"].min()
    alert_cnt_diff = max_alert_cnt - min_alert_cnt
    if max_alert_cnt > 0 and alert_cnt_diff == 0:
        alert_cnt_diff = 0.1
        min_alert_cnt = min_alert_cnt - 1
    # fix datatype of alert_cnt column
    recommendation_df["alert_cnt"] = recommendation_df["alert_cnt"].astype(float)
    # update the impact score for each row
    for i in recommendation_df.index:
        recommendation_df.at[i, "impact_score"] = (
            (recommendation_df.at[i, "org_cnt"] - min_org_cnt)
            * 100.0
            / (org_cnt_diff * 3.0)
            + (recommendation_df.at[i, "dev_cnt"] - min_dev_cnt)
            * 100.0
            / (dev_cnt_diff * 3.0)
            + (recommendation_df.at[i, "alert_cnt"] - min_alert_cnt)
            * 100.0
            / (alert_cnt_diff * 3.0)
        )
    return recommendation_df
